summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorJeremy Huddleston <eradicator@gentoo.org>2005-08-09 08:34:23 +0000
committerJeremy Huddleston <eradicator@gentoo.org>2005-08-09 08:34:23 +0000
commit5c6f3715ddaa8c05ba95389041934d8bca6079e1 (patch)
treee6cb0e9df5f864291fdfa97070ee87a017d7b16f /sys-devel/gcc-config/files
parentStable on amd64. (diff)
downloadgentoo-2-5c6f3715ddaa8c05ba95389041934d8bca6079e1.tar.gz
gentoo-2-5c6f3715ddaa8c05ba95389041934d8bca6079e1.tar.bz2
gentoo-2-5c6f3715ddaa8c05ba95389041934d8bca6079e1.zip
Killing 1.4.0. Working on gcc-config-2.0 in gentoo/src/toolchain/gcc-config.
(Portage version: 2.0.51.22-r2)
Diffstat (limited to 'sys-devel/gcc-config/files')
-rw-r--r--sys-devel/gcc-config/files/digest-gcc-config-1.4.00
-rwxr-xr-xsys-devel/gcc-config/files/gcc-config-1.4.0578
2 files changed, 0 insertions, 578 deletions
diff --git a/sys-devel/gcc-config/files/digest-gcc-config-1.4.0 b/sys-devel/gcc-config/files/digest-gcc-config-1.4.0
deleted file mode 100644
index e69de29bb2d1..000000000000
--- a/sys-devel/gcc-config/files/digest-gcc-config-1.4.0
+++ /dev/null
diff --git a/sys-devel/gcc-config/files/gcc-config-1.4.0 b/sys-devel/gcc-config/files/gcc-config-1.4.0
deleted file mode 100755
index a43d79a4a14a..000000000000
--- a/sys-devel/gcc-config/files/gcc-config-1.4.0
+++ /dev/null
@@ -1,578 +0,0 @@
-#!/bin/bash
-# Copyright 1999-2005 Gentoo Foundation
-# Distributed under the terms of the GNU General Public License v2
-# $Header: /var/cvsroot/gentoo-x86/sys-devel/gcc-config/files/gcc-config-1.4.0,v 1.13 2005/04/28 23:42:25 vapier Exp $
-
-trap ":" INT QUIT TSTP
-
-source /sbin/functions.sh || {
- echo "$0: Could not source /sbin/functions.sh!"
- exit 1
-}
-umask 022
-
-usage() {
-cat << "USAGE_END"
-Usage: gcc-config [options] [CC Profile]
-Change the current cc/gcc profile, or give info about profiles.
-
-Options:
- -O, --use-old Use the old profile if one was selected.
- -P, --use-portage-chost Only set to given profile if its CHOST is the
- same as that set for portage in /etc/make.conf
- (or one of other portage config files...).
- -c, --get-current-profile Print current used gcc profile.
- -l, --list-profiles Print a list of available profiles.
- -E, --print-environ Print environment that can be used to setup the
- current gcc profile, or a specified one.
- -B, --get-bin-path Print path where binaries of the given/current
- profile are located.
- -L, --get-lib-path Print path where libraries of the given/current
- profile are located.
- -X, --get-stdcxx-incdir Print path where g++ include files of the
- given/current profile are located.
-
-Profile names are of the form: <CHOST>-<gcc version>
-For example: i686-pc-linux-gnu-3.2.1
-USAGE_END
- exit $1
-}
-[[ $# -lt 1 ]] && usage 1
-
-find_path() {
- [[ -z $1 ]] && return 0
-
- local fullpath="$(type -P $1)"
-
- if [[ -x ${fullpath} ]] ; then
- echo "${fullpath}"
- return 0
- fi
-
- for x in /bin /sbin /usr/bin /usr/sbin /usr/local/bin /usr/local/sbin ; do
- if [[ -x ${x}/$1 ]] && [[ -r ${x}/$1 ]] ; then
- echo "${x}/$1"
- return 0
- fi
- done
-
- return 0
-}
-
-cmd_setup() {
- # Sourcing /etc/env.d/gcc/${CC_COMP} is going to mess up
- # PATH among things...
- CP=$(find_path cp)
- RM=$(find_path rm)
- MV=$(find_path mv)
- LN=$(find_path ln)
- CAT=$(find_path cat)
- AWK=$(find_path gawk)
- GREP=$(find_path grep)
- FIND=$(find_path find)
- CHMOD=$(find_path chmod)
- TOUCH=$(find_path touch)
- PORTAGEQ=$(find_path portageq)
- ENV_UPDATE=$(find_path env-update)
-}
-
-get_real_chost() {
- [[ -n ${REAL_CHOST} ]] && return 0
-
- export REAL_CHOST=$(env -i ${PORTAGEQ} envvar CHOST)
-
- if [[ -z ${REAL_CHOST} ]] ; then
- eerror "$0: Could not get portage CHOST!"
- return 1
- fi
-}
-
-is_cross_compiler() {
- get_real_chost
- [[ ${CC_COMP/${REAL_CHOST}} == ${CC_COMP} ]]
-}
-
-create_script_wrapper() {
- cat > ${1} <<EOF
-#!/bin/bash
-
-if [[ -z \${ABI} ]]; then
- export ABI="custom"
- export CFLAGS_custom="${3}"
-fi
-
-exec ${2} "\${@}"
-EOF
-
- ${CHMOD} 755 ${1}
-}
-
-switch_profile() {
- local MY_LDPATH=
- local GCC_PROFILES=
- local OLD_CC_COMP=
- local GCC_BIN_PATH=
-
- if [[ "$(id -u)" -ne 0 ]] ; then
- eerror "$0: Must be root."
- exit 1
- fi
-
- ebegin "Switching to ${CC_COMP} compiler"
-
- # Sourcing /etc/env.d/gcc/${CC_COMP} is going to mess up
- # PATH among things...
- cmd_setup
-
- if ! is_cross_compiler ; then
- # Order our profiles to have the default first ...
- # We do this so that we can have them ordered with default
- # first in /etc/ld.so.conf, as the logical is that all
- # compilers for default CHOST will be used to compile stuff,
- # and thus we want all their lib paths in /etc/ld.so.conf ...
- get_real_chost
- GCC_PROFILES="$(${FIND} "${GCC_ENV_D}" -maxdepth 1 -name "${REAL_CHOST}-*" -a ! -name "${CC_COMP}")"
- GCC_PROFILES="${GCC_ENV_D}/${CC_COMP} ${GCC_PROFILES}"
-
- # Extract all LDPATH's for our CHOST
- MY_LDPATH=""
- for x in ${GCC_PROFILES} ; do
- if [[ -f ${x} ]] ; then
- source "${x}"
-
- # Handle LDPATH's that have multiple directories
- local old_IFS="${IFS}"
- export IFS=":"
- local sub_ldpath=
- for sub_ldpath in ${LDPATH} ; do
- if [[ -d ${sub_ldpath} ]] ; then
- if [[ ${MY_LDPATH/:${sub_ldpath}} == ${MY_LDPATH} ]] ; then
- MY_LDPATH="${MY_LDPATH}:${sub_ldpath}"
- fi
- fi
- done
- export IFS="${old_IFS}"
- fi
- done
- MY_LDPATH="${MY_LDPATH:1}" # trim leading :
- fi
-
- # Setup things properly again for this profile
- unset GCC_SPECS LDPATH
- source "${GCC_ENV_D}/${CC_COMP}"
- OLD_CC_COMP=$(get_current_profile)
- CTARGET="${CTARGET:-${REAL_CHOST}}"
-
- ENV_FILE="${ENV_D}/05gcc-${CTARGET}"
- CONFIG_FILE="${GCC_ENV_D}/config-${CTARGET}"
-
- # What kind of env.d entry are we going to generate ?
- if is_cross_compiler ; then
- # Only keep PATH/ROOTPATH
- ${AWK} '/^(PATH|ROOTPATH)=/ {print $0}' \
- "${GCC_ENV_D}/${CC_COMP}" > "${ENV_FILE}"
-
- echo "CURRENT=${CC_COMP}" > "${CONFIG_FILE}"
- else
- # Pass all by default
- ${AWK} '!/^(STDCXX_INCDIR|LDPATH|CC|CXX|CTARGET|GCCBITS|GCC_SPECS|CFLAGS_.*|FAKE_TARGETS)=/ {print $0}' \
- "${GCC_ENV_D}/${CC_COMP}" > "${ENV_FILE}"
- echo "LDPATH=\"${MY_LDPATH}\"" >> "${ENV_FILE}"
- if [[ -n ${GCC_SPECS} ]] && [[ -e ${ROOT}/${GCC_SPECS} ]] ; then
- echo "GCC_SPECS=\"${GCC_SPECS}\"" >> "${ENV_FILE}"
- else
- # People need to rebuild their gcc or setting GCC_SPECS to
- # "" will cause issues again :(
- if [[ ${ROOT} != "/" ]] ; then
- echo "GCC_SPECS=\"\"" >> "${ENV_FILE}"
- else
- if ! GCC_SPECS="" /usr/bin/${CTARGET}-gcc -v &>/dev/null ; then
- echo
- ewarn "Your gcc has a bug with GCC_SPECS."
- ewarn "Please re-emerge gcc."
- ewarn "http://bugs.gentoo.org/show_bug.cgi?id=68395"
- echo
- else
- echo "GCC_SPECS=\"\"" >> "${ENV_FILE}"
- fi
- fi
- fi
-
- echo "CURRENT=${CC_COMP}" > "${CONFIG_FILE}"
- fi
-
- # Save PATH
- GCC_BIN_PATH="${PATH}"
- # Fix environment
- source /etc/profile
- umask 022
-
- # Update the wrappers for this profile
- local cross="gcc c++ g++ f77 g77 gcj gcjh gfortran"
- local native="${cross} cpp gccbug gcj-jar gcov gij grepjar jcf-dump jv-convert jv-scan rmic rmiregistry"
- is_cross_compiler && native=""
- for x in ${native}; do
- # Make sure we have no stale wrappers
- ${RM} -f "${ROOT}/usr/bin/${x}"
- [[ ${x:${#x}-3} == "gcc" || ${x:${#x}-3} == "g++" ]] \
- && ${RM} -f "${ROOT}/usr/bin/${x}"{32,64}
-
- # Only install a wrapper if the binary exists ...
- # We want to figure out the 'reference file' for each
- # wrapper (the binary we're 'wrapping') so that we can
- # sync mtimes together. This makes things like ccache
- # happy. See Bug #70548 for more info.
-
- local ref=${ROOT}/${GCC_BIN_PATH}/${x}
- [[ ${x} == "cc" ]] && ref=${ROOT}/${GCC_BIN_PATH}/gcc
- if [[ -x ${ref} ]] ; then
- ${CP} -f "${WRAPPER}" \
- "${ROOT}/usr/bin/${x}"
- ${TOUCH} -r "${ref}" "${ROOT}/usr/bin/${x}"
-
- # Install 32bit and 64bit wrappers if need be
- # This should probably get folded back into the wrapper ...
- if [[ ${x:${#x}-3} == "gcc" ]] || [[ ${x:${#x}-3} == "g++" ]] ; then
- for bits in ${GCCBITS} ; do
- ${CP} -f "${WRAPPER}" \
- "${ROOT}/usr/bin/${x}${bits}"
- done
- fi
- fi
- done
-
- for x in ${cross}; do
- ref=${ROOT}/${GCC_BIN_PATH}/${CTARGET}-${x}
-
- if [[ -f ${ref} ]]; then
- # Don't use gccbits here... delete them if they exist.
- [[ -f ${ROOT}/usr/bin/${CTARGET}-${x}32 ]] && \
- ${RM} -f "${ROOT}"/usr/bin/${CTARGET}-${x}32
- [[ -f ${ROOT}/usr/bin/${CTARGET}-${x}64 ]] && \
- ${RM} -f "${ROOT}"/usr/bin/${CTARGET}-${x}64
-
- ${CP} -f ${WRAPPER} \
- "${ROOT}"/usr/bin/${CTARGET}-${x}
- ${CHMOD} 755 "${ROOT}"/usr/bin/${CTARGET}-${x}
- ${TOUCH} -r "${ref}" "${ROOT}"/usr/bin/${CTARGET}-${x}
-
- local cctarget
- for cctarget in ${FAKE_TARGETS}; do
- local var="CFLAGS_${cctarget//-/_}"
- if [[ ! -f ${GCC_ENV_D}/config-${cctarget} ]]; then
- create_script_wrapper "${ROOT}"/usr/bin/${cctarget}-${x} ${CTARGET}-${x} "${!var}"
- ${TOUCH} -r "${ref}" "${ROOT}"/usr/bin/${cctarget}-${x}
- fi
- done
-
- if ! is_cross_compiler && [[ -n "${CFLAGS_default}" ]]; then
- create_script_wrapper "${ROOT}"/usr/bin/${x} ${CTARGET}-${x} "${CFLAGS_default}"
- ${TOUCH} -r "${ref}" "${ROOT}"/usr/bin/${x}
- fi
- fi
- done
-
- # Only install cpp if switching to a native one
- if ! is_cross_compiler && [[ ${CTARGET} != *-solaris* ]] ; then
- ${RM} -f "${ROOT}/lib/cpp"
- ${CP} -f "${WRAPPER}" "${ROOT}/lib/cpp"
- fi
-
- # We need to make sure that libgcc_s.so / libunwind.so make it into /lib.
- # On many systems (x86/amd64/etc...), this will probably never matter,
- # but on other systems (arm/mips/etc...), this is quite critical.
- # http://bugs.gentoo.org/show_bug.cgi?id=60190
- #
- # Don't copy the library if we're being called by portage because
- # this may cause python to start segfaulting all over the place
- # since on many arches, it uses libgcc_s.so.
- if [[ -z ${PORTAGE_CALLER} ]] && ! is_cross_compiler ; then
- for multilib in $(${ROOT}/${GCC_BIN_PATH}/${CTARGET}-gcc -print-multi-lib); do
- multiarg=${multilib#*;}
- multiarg=${multiarg/@/-}
- multilibdir=${multilib%;*}
- libdir="lib/$(${ROOT}/${GCC_BIN_PATH}/${CTARGET}-gcc ${multiarg} -print-multi-os-directory)"
- for gcclib in gcc_s unwind ; do
- if [[ -e ${ROOT}/${LDPATH}/${multildir}/lib${gcclib}.so ]]; then
- ${RM} -f "${ROOT}/${libdir}"/lib${gcclib}.so*
- ${CP} -pP "${ROOT}/${LDPATH}"/${multilibdir}/lib${gcclib}.so* "${ROOT}/${libdir}"/
- fi
- done
- done
- unset multilib
- unset multilibdir
- unset multiarg
- unset libdir
- fi
-
- if [[ ${ROOT} == "/" ]] && [[ ${OLD_CC_COMP} != ${CC_COMP} ]] ; then
- ${ENV_UPDATE} &>/dev/null
- fi
-
- eend 0
-
- if [[ ${ROOT} == "/" ]] && [[ ${OLD_CC_COMP} != ${CC_COMP} ]] ; then
- echo
- ewarn "If you intend to use the gcc from the new profile in an already"
- ewarn "running shell, please remember to do:"
- echo
- ewarn " # source /etc/profile"
- echo
- fi
-
- return 0
-}
-
-get_current_profile() {
- get_real_chost
- CTARGET="${CTARGET:-${REAL_CHOST}}"
- local conf="${GCC_ENV_D}/config-${CTARGET}"
-
- if [[ ! -f ${conf} ]] ; then
- eerror "$0: No gcc profile is active!"
- return 1
- fi
-
- source "${conf}"
-
- if [[ -z ${CURRENT} ]] ; then
- eerror "$0: No gcc profile is active!"
- return 1
- fi
-
- echo "${CURRENT}"
-
- return 0
-}
-
-list_profiles() {
- get_real_chost
-
- local i=1
-
- if [[ ! -f ${GCC_ENV_D}/config-${REAL_CHOST} ]] ; then
- eerror "$0: No gcc profile is active; please select one!"
- else
- get_current_profile >/dev/null
- fi
-
- if [[ ${ROOT} != "/" ]] ; then
- echo "Using gcc-config info in ${ROOT}"
- fi
- for x in "${GCC_ENV_D}"/* ; do
- if [[ -f ${x} ]] && [[ ${x/\/config} == ${x} ]] ; then
- x=${x##*/}
- [[ ${x} == ${CURRENT} ]] && x="${x} *"
- echo "[${i}] ${x}"
- i=$((i + 1))
- fi
- done
-}
-
-print_environ() {
- local OLDPATH="${PATH}"
- local ENV_CMD=
- local SET_ELEMENT=
-
- source "${GCC_ENV_D}/${CC_COMP}"
-
- case ${SHELL} in
- */csh|*/tsch)
- ENV_CMD="setenv"
- SET_ELEMENT=" "
- ;;
- *)
- ENV_CMD="export"
- SET_ELEMENT="="
- ;;
- esac
-
- echo "${ENV_CMD} PATH${SET_ELEMENT}\"${PATH}:${OLDPATH}\""
-}
-
-get_bin_path() {
- if [[ -e ${GCC_ENV_D}/${CC_COMP} ]] ; then
- source "${GCC_ENV_D}/${CC_COMP}"
- echo "${PATH}"
- else
- echo "no-config"
- echo "${GCC_ENV_D}/${CC_COMP} doesnt exist" 1>&2
- fi
-
- return 0
-}
-
-get_lib_path() {
- if [[ -e ${GCC_ENV_D}/${CC_COMP} ]] ; then
- source "${GCC_ENV_D}/${CC_COMP}"
- echo "${LDPATH}"
- else
- echo "no-config"
- echo "${GCC_ENV_D}/${CC_COMP} doesnt exist" 1>&2
- fi
-
- return 0
-}
-
-get_stdcxx_incdir() {
- if [[ -e ${GCC_ENV_D}/${CC_COMP} ]] ; then
- source "${GCC_ENV_D}/${CC_COMP}"
- echo "${LDPATH}/include/${STDCXX_INCDIR}"
- else
- echo "no-config"
- echo "${GCC_ENV_D}/${CC_COMP} doesnt exist" 1>&2
- fi
-
- return 0
-}
-
-NEED_ACTION="yes"
-DOIT="switch_profile"
-CHECK_CHOST="no"
-
-CC_COMP=
-[[ -z ${ROOT} ]] && ROOT="/"
-[[ ${ROOT:-1} != "/" ]] && ROOT="${ROOT}/"
-LIBEXECDIR="${ROOT}usr/lib/misc"
-WRAPPER="${LIBEXECDIR}/gcc-config-wrapper"
-ENV_D="${ROOT}etc/env.d"
-GCC_ENV_D="${ENV_D}/gcc"
-
-for x in "$@" ; do
- case "${x}" in
- # Only use specified compiler if one is not already selected.
- -O|--use-old)
- if get_current_profile &>/dev/null ; then
- CC_COMP="$(get_current_profile)"
- fi
- ;;
- -P|--use-portage-chost)
- CHECK_CHOST="yes"
- ;;
- -c|--get-current-profile)
- if [[ ${NEED_ACTION} == "yes" ]] ; then
- NEED_ACTION="no"
- DOIT="get_current_profile"
- fi
- ;;
- -l|--list-profiles)
- if [[ ${NEED_ACTION} == "yes" ]] ; then
- NEED_ACTION="no"
- DOIT="list_profiles"
- fi
- ;;
- -E|--print-environ)
- if [[ ${NEED_ACTION} == "yes" ]] ; then
- NEED_ACTION="no"
- DOIT="print_environ"
- fi
- ;;
- -B|--get-bin-path)
- if [[ ${NEED_ACTION} == "yes" ]] ; then
- NEED_ACTION="no"
- DOIT="get_bin_path"
- fi
- ;;
- -L|--get-lib-path)
- if [[ ${NEED_ACTION} == "yes" ]] ; then
- NEED_ACTION="no"
- DOIT="get_lib_path"
- fi
- ;;
- -X|--get-stdcxx-incdir)
- if [[ ${NEED_ACTION} == "yes" ]] ; then
- NEED_ACTION="no"
- DOIT="get_stdcxx_incdir"
- fi
- ;;
- -h|--help)
- usage 0
- exit 0
- ;;
- -v|--version)
- echo "gcc-config-PORTAGE-VERSION"
- exit 0
- ;;
- -*)
- eerror "$0: Invalid switch! Run $0 without parameters for help."
- exit 1
- ;;
- *)
- if [[ -z ${CC_COMP} ]] ; then
- if [[ -z $(echo ${x} | tr -d '[:digit:]') ]] ; then
- # User gave us a # representing the profile
- i=1
- for y in "${GCC_ENV_D}"/* ; do
- [[ ${y/\/config} != ${y} ]] && continue
-
- if [[ -f ${y} ]] && [[ ${x} == ${i} ]] ; then
- CC_COMP="${y##*/}"
- break
- fi
- i=$((i + 1))
- done
- else
- # User gave us a full HOST-gccver
- x=${x##*/}
- if [[ ${DOIT} != "get_current_profile" ]] && \
- [[ ! -f ${GCC_ENV_D}/${x} ]]
- then
- eerror "$0: Could not locate '$x' in '${GCC_ENV_D}/'!"
- exit 1
- fi
- CC_COMP="${x}"
- fi
- else
- eerror "$0: Too many arguments! Run $0 without parameters for help."
- exit 1
- fi
- ;;
- esac
-done
-
-if [[ ${DOIT} == "switch_profile" ]] && [[ -z ${CC_COMP} ]] ; then
- usage 1
-fi
-
-if [[ -z ${CC_COMP} ]] ; then
- if get_current_profile &>/dev/null
- then
- CC_COMP="$(get_current_profile)"
- else
- list_profiles
- exit 1
- fi
-fi
-
-if [[ ${DOIT} != "get_current_profile" ]] ; then
- GCC_LIB=$(source "${GCC_ENV_D}/${CC_COMP}"
- cmd_setup
- echo ${LDPATH} | ${AWK} -F/ '{ print "/"$2"/"$3"/"$4"/" }')
-
- CC_COMP_TARGET=$(echo ${CC_COMP} | awk -F- '{ print $1"-"$2"-"$3"-"$4 }')
- CC_COMP_VERSION=${CC_COMP/${CC_COMP_TARGET}-/}
-
- if [[ ! -d ${ROOT}/${GCC_LIB}/${CC_COMP_TARGET}/${CC_COMP_VERSION} ]]; then
- CC_COMP_VERSION=${CC_COMP_VERSION%-*}
- fi
-
- if [[ ! -d ${ROOT}/${GCC_LIB}/${CC_COMP_TARGET}/${CC_COMP_VERSION} ]] || \
- [[ ! -f ${GCC_ENV_D}/${CC_COMP} ]]
- then
- eerror "$0: Profile does not exist or invalid setting for ${GCC_ENV_D}/${CC_COMP}" 1>&2
- #exit 1
- fi
-fi
-
-if [[ ${CHECK_CHOST} == "yes" ]] ; then
- # Chosen CHOST are not the same as the real CHOST according to
- # make.conf, and --use-portage-chost option was given, so do nothing
- get_real_chost
- CC_COMP_TARGET=$(echo ${CC_COMP} | awk -F- '{ print $1"-"$2"-"$3"-"$4 }')
- [[ ${CC_COMP_TARGET} != ${REAL_CHOST} ]] && exit 0
-fi
-
-eval ${DOIT}
-
-
-# vim:ts=4